From c6a7c7348d400406d68e6e7e4fceb239de3413fc Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Elan=20Ruusam=C3=A4e?= <glen@delfi.ee>
Date: Tue, 4 Mar 2014 00:33:57 +0200
Subject: [PATCH] [OHAI-295] LXC detection

adopted from Jorge Espada version from
https://github.com/opscode/ohai/pull/48
---
 lib/ohai/plugins/linux/virtualization.rb | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

diff --git a/lib/ohai/plugins/linux/virtualization.rb b/lib/ohai/plugins/linux/virtualization.rb
index 9cdaa9b..39bc364 100644
--- a/lib/ohai/plugins/linux/virtualization.rb
+++ b/lib/ohai/plugins/linux/virtualization.rb
@@ -123,3 +123,20 @@
      end
   end
 end
+
+# Detect Linux lxc-container
+if File.exists?("/proc/1/cpuset")
+  proc_cpuset = File.read("/proc/1/cpuset")
+  if proc_cpuset.eql?("/\n") && File.directory?("/var/lib/lxc")
+    virtualization[:system] = "linux-lxc"
+    virtualization[:role] = "host"
+  else
+    if File.exist?("/proc/1/environ")
+      proc_environ = File.read("/proc/1/environ")
+      if proc_environ.match('container=lxc')
+        virtualization[:system] = "linux-lxc"
+        virtualization[:role] = "guest"
+      end
+    end
+  end
+end
-- 
1.8.5.5

